#include <pluginlib/class_list_macros.h>
#include "NodeletTalker.h"
#include <ros/ros.h>
#include "autonom_a/Num.h"

PLUGINLIB_EXPORT_CLASS(autonom_a::NodeletTalker, nodelet::Nodelet);

namespace autonom_a
{
	NodeletTalker::NodeletTalker(ros::NodeHandle &nh, std::string &name) : nh_(nh), name_(name) {}
	NodeletTalker::NodeletTalker() {}
	NodeletTalker::~NodeletTalker()
	{
		tPub.join();
	}
	void NodeletTalker::onInit()
	{
		NODELET_INFO("Initializing nodelet: Talker");
		tPub = boost::thread([this]() {
			ros::Publisher top1_pub = nh_.advertise<Num>("topic1", 1000);
			ros::Rate loop_rate(10);
	
			int count = 0;
			while (ros::ok())
			{
				Num msg;
				msg.x = count++;
				msg.y = count++;
				
				//NODELET_DEBUG("%s, %s", std::to_string(msg.x).c_str(), std::to_string(msg.y).c_str());
	
				top1_pub.publish(msg);
				ros::spinOnce();
				loop_rate.sleep();
			}
		});
		NODELET_INFO("Talker thread runs...");
	}
}
